/*
 * lilJudd
 * Copyright (C) 2023 moonleay
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package net.moonleay.lilJudd.extensions

import com.kotlindiscord.kord.extensions.extensions.Extension
import com.kotlindiscord.kord.extensions.extensions.publicSlashCommand
import com.kotlindiscord.kord.extensions.types.respond
import dev.kord.common.Color
import dev.kord.rest.builder.message.create.actionRow
import net.moonleay.lilJudd.util.EmbedUtil
import net.moonleay.lilJudd.util.MessageUtil

/* This extension has no proper use.
   It is used in testing to test stuff, without having to wait for certain events to trigger. */
class TestExtension : Extension() {
    override val name = "test"
    override val allowApplicationCommandInDMs: Boolean
        get() = false

    override suspend fun setup() {
        publicSlashCommand {
            name = "test"
            description = "Test game"
            this.action {
                this.respond {
                    this.embeds.add(
                        MessageUtil.getEmbedWithTable(
                            Color(0X4C4645),
                            "",
                            "MONDAY, 22.05.2023",
                            mapOf(
                                "Is available" to listOf(),
                                "May be available" to listOf(),
                                "Is not available" to listOf()
                            )
                        )
                    )

                    this.actionRow {
                        this.components.addAll(EmbedUtil.getTimePlannerButtons().components)
                    }
                }
            }
        }
    }
}
