/*
 * lilJudd
 * Copyright (C) 2023 moonleay
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package net.moonleay.lilJudd.extensions

import com.kotlindiscord.kord.extensions.extensions.Extension
import com.kotlindiscord.kord.extensions.extensions.publicSlashCommand
import dev.kord.common.Color
import net.moonleay.botendo.build.BuildConstants
import net.moonleay.lilJudd.util.MessageUtil

class VersionExtension : Extension() {
    override val name = "version"
    override suspend fun setup() {
        publicSlashCommand {
            name = "version"
            description = "Show infos about the bot"
            this.action {
                MessageUtil.sendEmbedForPublicSlashCommand(
                    this,
                    Color(0x52E01A),
                    "Lil' Judd",
                    "Lil' Judd ***v." + BuildConstants.version + "***\n" +
                            "Kord-Extensions ***v." + BuildConstants.kordVersion + "***\n" +
                            "Coroutines ***v." + BuildConstants.coroutinesVersion + "***\n" +
                            "Krontab ***v." + BuildConstants.krontabVersion + "***"
                )
            }
        }
    }
}
